/*
 * Copyright (C) 1996,1997,1998,1999
 *	SHUDO Kazuyuki
 *
 * Permission to use, copy, modify and distribute this software
 * and its documentation for non-commercial purposes and without
 * fee is hereby granted provided this copyright notice.
 *
 * $Id$
 */

/* native methods for MetaField */

#include <stdio.h>	/* for NULL */
#include <string.h>	/* for strlen(), strcmp() */

#include "NET_shudo_moba_reflect_MetaField.h"

#include "moba.h"


/*
 * $B%U%#!<%k%I$NCM$r<hF@(B, $B%;%C%H(B
 */

#define DEF_GET_COMMON(ST, T1, T2) \
JNIEXPORT T1 JNICALL Java_NET_shudo_moba_reflect_MetaField_get##ST##T2##ValueCommon\
  (JNIEnv *env, jobject _this, jclass clazz, jobject obj) {\
  jobject nameStr, sigStr;\
  const char *name, *sig;\
  jfieldID fid;\
\
  T1 data;\
\
  fid = (*env)->GetFieldID(env, (*env)->GetObjectClass(env, _this),\
	"thisSig", "Ljava/lang/String;");\
  sigStr = (*env)->GetObjectField(env, _this, fid);\
  sig = (*env)->GetStringUTFChars(env, sigStr, NULL);\
\
  fid = (*env)->GetFieldID(env, (*env)->GetObjectClass(env, _this),\
	"thisName", "Ljava/lang/String;");\
  nameStr = (*env)->GetObjectField(env, _this, fid);\
  name = (*env)->GetStringUTFChars(env, nameStr, NULL);\
\
  fid = (*env)->Get##ST##FieldID(env, clazz, name, sig);\
  data = (*env)->Get##ST##T2##Field(env, obj, fid);\
\
  (*env)->ReleaseStringUTFChars(env, sigStr, sig);\
  (*env)->ReleaseStringUTFChars(env, nameStr, name);\
\
  return data;\
}\

#define DEF_GET(T1, T2) \
JNIEXPORT T1 JNICALL Java_NET_shudo_moba_reflect_MetaField_get##T2##Value\
  (JNIEnv *env, jobject _this, jobject obj) {\
  jclass clazz = (*env)->GetObjectClass(env, obj);\
  return JNICALL Java_NET_shudo_moba_reflect_MetaField_get##T2##ValueCommon(\
	env, _this, clazz, obj);\
}\

#define DEF_GET_STATIC(T1, T2) \
JNIEXPORT T1 JNICALL Java_NET_shudo_moba_reflect_MetaField_getStatic##T2##Value\
  (JNIEnv *env, jobject _this) {\
  jclass clazz;\
  jfieldID fid;\
\
  fid = (*env)->GetFieldID(env, (*env)->GetObjectClass(env, _this),\
	"thisClass", "Ljava/lang/Class;");\
  clazz = (*env)->GetObjectField(env, _this, fid);\
\
  return JNICALL Java_NET_shudo_moba_reflect_MetaField_getStatic##T2##ValueCommon(\
	env, _this, clazz, (jobject)clazz);\
}\

#define DEF_SET_COMMON(ST, T1, T2) \
JNIEXPORT void JNICALL Java_NET_shudo_moba_reflect_MetaField_set##ST##T2##ValueCommon\
  (JNIEnv *env, jobject _this, jclass clazz, jobject obj, T1 data) {\
  jobject nameStr, sigStr;\
  const char *name, *sig;\
  jfieldID fid;\
\
  fid = (*env)->GetFieldID(env, (*env)->GetObjectClass(env, _this),\
	"thisSig", "Ljava/lang/String;");\
  sigStr = (*env)->GetObjectField(env, _this, fid);\
  sig = (*env)->GetStringUTFChars(env, sigStr, NULL);\
\
  fid = (*env)->GetFieldID(env, (*env)->GetObjectClass(env, _this),\
	"thisName", "Ljava/lang/String;");\
  nameStr = (*env)->GetObjectField(env, _this, fid);\
  name = (*env)->GetStringUTFChars(env, nameStr, NULL);\
\
  fid = (*env)->Get##ST##FieldID(env, clazz, name, sig);\
  (*env)->Set##ST##T2##Field(env, obj, fid, data);\
\
  (*env)->ReleaseStringUTFChars(env, sigStr, sig);\
  (*env)->ReleaseStringUTFChars(env, nameStr, name);\
}\

#define DEF_SET(T1, T2) \
JNIEXPORT void JNICALL Java_NET_shudo_moba_reflect_MetaField_set##T2##Value\
  (JNIEnv *env, jobject _this, jobject obj, T1 data) {\
  jclass clazz = (*env)->GetObjectClass(env, obj);\
  JNICALL Java_NET_shudo_moba_reflect_MetaField_set##T2##ValueCommon(\
	env, _this, clazz, obj, data);\
}\

#define DEF_SET_STATIC(T1, T2)\
JNIEXPORT void JNICALL Java_NET_shudo_moba_reflect_MetaField_setStatic##T2##Value\
  (JNIEnv *env, jobject _this, T1 data) {\
  jclass clazz;\
  jfieldID fid;\
\
  fid = (*env)->GetFieldID(env, (*env)->GetObjectClass(env, _this),\
	"thisClass", "Ljava/lang/Class;");\
  clazz = (*env)->GetObjectField(env, _this, fid);\
\
  JNICALL Java_NET_shudo_moba_reflect_MetaField_setStatic##T2##ValueCommon(\
	env, _this, clazz, (jobject) clazz, data);\
}\
  

DEF_GET_COMMON(, jboolean, Boolean)
DEF_GET_COMMON(, jbyte, Byte)
DEF_GET_COMMON(, jchar, Char)
DEF_GET_COMMON(, jshort, Short)
DEF_GET_COMMON(, jint, Int)
DEF_GET_COMMON(, jlong, Long)
DEF_GET_COMMON(, jfloat, Float)
DEF_GET_COMMON(, jdouble, Double)
DEF_GET_COMMON(, jobject, Object)
DEF_GET_COMMON(Static, jboolean, Boolean)
DEF_GET_COMMON(Static, jbyte, Byte)
DEF_GET_COMMON(Static, jchar, Char)
DEF_GET_COMMON(Static, jshort, Short)
DEF_GET_COMMON(Static, jint, Int)
DEF_GET_COMMON(Static, jlong, Long)
DEF_GET_COMMON(Static, jfloat, Float)
DEF_GET_COMMON(Static, jdouble, Double)
DEF_GET_COMMON(Static, jobject, Object)
DEF_GET(jboolean, Boolean)
DEF_GET(jbyte, Byte)
DEF_GET(jchar, Char)
DEF_GET(jshort, Short)
DEF_GET(jint, Int)
DEF_GET(jlong, Long)
DEF_GET(jfloat, Float)
DEF_GET(jdouble, Double)
DEF_GET(jobject, Object)
DEF_GET_STATIC(jboolean, Boolean)
DEF_GET_STATIC(jbyte, Byte)
DEF_GET_STATIC(jchar, Char)
DEF_GET_STATIC(jshort, Short)
DEF_GET_STATIC(jint, Int)
DEF_GET_STATIC(jlong, Long)
DEF_GET_STATIC(jfloat, Float)
DEF_GET_STATIC(jdouble, Double)
DEF_GET_STATIC(jobject, Object)

DEF_SET_COMMON(, jboolean, Boolean)
DEF_SET_COMMON(, jbyte, Byte)
DEF_SET_COMMON(, jchar, Char)
DEF_SET_COMMON(, jshort, Short)
DEF_SET_COMMON(, jint, Int)
DEF_SET_COMMON(, jlong, Long)
DEF_SET_COMMON(, jfloat, Float)
DEF_SET_COMMON(, jdouble, Double)
DEF_SET_COMMON(, jobject, Object)
DEF_SET_COMMON(Static, jboolean, Boolean)
DEF_SET_COMMON(Static, jbyte, Byte)
DEF_SET_COMMON(Static, jchar, Char)
DEF_SET_COMMON(Static, jshort, Short)
DEF_SET_COMMON(Static, jint, Int)
DEF_SET_COMMON(Static, jlong, Long)
DEF_SET_COMMON(Static, jfloat, Float)
DEF_SET_COMMON(Static, jdouble, Double)
DEF_SET_COMMON(Static, jobject, Object)
DEF_SET(jboolean, Boolean)
DEF_SET(jbyte, Byte)
DEF_SET(jchar, Char)
DEF_SET(jshort, Short)
DEF_SET(jint, Int)
DEF_SET(jlong, Long)
DEF_SET(jfloat, Float)
DEF_SET(jdouble, Double)
DEF_SET(jobject, Object)
DEF_SET_STATIC(jboolean, Boolean)
DEF_SET_STATIC(jbyte, Byte)
DEF_SET_STATIC(jchar, Char)
DEF_SET_STATIC(jshort, Short)
DEF_SET_STATIC(jint, Int)
DEF_SET_STATIC(jlong, Long)
DEF_SET_STATIC(jfloat, Float)
DEF_SET_STATIC(jdouble, Double)
DEF_SET_STATIC(jobject, Object)
