/*
 * Copyright (C) 1996,1997,1998,2003
 *	Kazuyuki Shudo
 *
 * Permission to use, copy, modify and distribute this software
 * and its documentation for non-commercial purposes and without
 * fee is hereby granted provided this copyright notice.
 *
 * $Id$
 */

package NET.shudo.moba.net;


import java.net.InetAddress;
import java.net.Socket;
import java.net.ServerSocket;
import java.io.IOException;


/**
 * Τä ServerSocket
 */
public class AccCtrldServSocket extends ServerSocket {
  private AccessController ac = null;

  public AccCtrldServSocket(AccessController ac, int port)
	throws IOException {
    super(port);
    this.ac = ac;
  }
  public AccCtrldServSocket(AccessController ac, int port, int backlog)
	throws IOException {
    super(port, backlog);
    this.ac = ac;
  }
  public AccCtrldServSocket(AccessController ac, int port, int backlog,
			InetAddress bindAddr) throws IOException {
    super(port, backlog, bindAddr);
    this.ac = ac;
  }


  /**
   * 椵 accept()overrides ServerSocket#accept()
   *
   * @see java.net.ServerSocket#accept()
   */
  public Socket accept() throws IOException {
    Socket sock = super.accept();

    if (ac == null)  return sock;

    if (ac.allow(sock))  return sock;
    else {
      sock.close();
      throw new IOException("Connection via " + sock + " is not allowed.");
    }
  }
}
