/*
 * Copyright (C) 1996,1997,1998,1999,2003
 *	Kazuyuki Shudo
 *
 * Permission to use, copy, modify and distribute this software
 * and its documentation for non-commercial purposes and without
 * fee is hereby granted provided this copyright notice.
 *
 * $Id$
 */

package NET.shudo.moba.place;


import java.net.Socket;
import java.net.ServerSocket;
import NET.shudo.moba.net.AccCtrldServSocket;
import java.io.IOException;
import NET.shudo.moba.lang.PlaceAddress;


/**
 * (MobaThread ) åɤǡ<BR>
 * MobaPlace 鵯ư롣<BR>
 * ġΰưåɤФThreadImporter ư롣
 *
 * @see NET.shudo.moba.place.MobaPlace
 * @see NET.shudo.moba.place.ThreadImporter
 */
public
class ThreadServer implements Runnable {
  private int port;

  private boolean debug = false;
  private int maxReceipt = 0;	//   0 means infinity
  private int importerCount = 0;	// ߤޤǤμ


  public ThreadServer(int port, boolean debug, int maxReceipt) {
    this.port = port + PlaceAddress.THREAD_PORT_DIFF;
    this.debug = debug;
    this.maxReceipt = maxReceipt;
  }


  public void run() {
    ServerSocket servsock = null;

    // ³륽åȤ
    try {
      servsock = new AccCtrldServSocket(MobaPlace.accessController, port);
    }
    catch (IOException e) { e.printStackTrace();  System.exit(1); }


    // main loop
    while (true) {
      Socket sock = null;

      try {
	sock = servsock.accept();
	if (debug) {
	  System.out.println("ThreadServer#run(): accepted.");
	  System.out.flush();
	}

	// TCP_NODELAY
	sock.setTcpNoDelay(true);
      }
      catch (IOException e) {
	if (debug)  e.printStackTrace();

	// busy loop 򤱤뤿ǰΤ
	try {  Thread.sleep(2000);  }
	catch (InterruptedException ie) {}

	continue;
      }


      importerCount++;

      Runnable importer = null;
      try { importer = new ThreadImporter(sock, debug); }
      catch (IOException e) {
	if (debug)  e.printStackTrace();
	continue;
      }
//      Thread t = new Thread(importer, "Thread Importer " + importerCount);
//      t.start();
      MobaPlace.threadPool.run(importer);

      if ((maxReceipt != 0) && (importerCount >= maxReceipt)) {
	Thread.currentThread().stop();
      }
    }	// while (true)
  }


  /**
   * ServerSocket  fd 롣ǥХåѡ
   */
  private int serverSocketFd(ServerSocket s) {
    NET.shudo.moba.reflect.MetaClass
	ServerSocketMf = null, SocketMf = null,
	SocketImplMf = null, FileDescriptorMf = null;
    Object obj = null;
    int fd = -1;

    try {
      ServerSocketMf =
	NET.shudo.moba.reflect.MetaClass.get("java.net.ServerSocket");
      SocketImplMf =
	NET.shudo.moba.reflect.MetaClass.get("java.net.SocketImpl");
      FileDescriptorMf =
	NET.shudo.moba.reflect.MetaClass.get("java.io.FileDescriptor");
      obj = ServerSocketMf.field("impl").getObjectValue(s);
      obj = SocketImplMf.field("fd").getObjectValue(obj);
      fd = FileDescriptorMf.field("fd").getIntValue(obj);
    }
    catch (Exception e) {
      e.printStackTrace();  System.exit(1);
    }

    return fd;
  }


  /**
   * Socket  fd 롣ǥХåѡ
   */
  private int socketFd(Socket s) {
    NET.shudo.moba.reflect.MetaClass
	ServerSocketMf = null, SocketMf = null,
	SocketImplMf = null, FileDescriptorMf = null;
    Object obj = null;
    int fd = -1;

    try {
      SocketMf =
	NET.shudo.moba.reflect.MetaClass.get("java.net.Socket");
      SocketImplMf =
	NET.shudo.moba.reflect.MetaClass.get("java.net.SocketImpl");
      FileDescriptorMf =
	NET.shudo.moba.reflect.MetaClass.get("java.io.FileDescriptor");
      obj = SocketMf.field("impl").getObjectValue(s);
      obj = SocketImplMf.field("fd").getObjectValue(obj);
      fd = FileDescriptorMf.field("fd").getIntValue(obj);
    }
    catch (Exception e) {
      e.printStackTrace();  System.exit(1);
    }

    return fd;
  }
}
