import java.io.IOException;
import java.net.InetAddress;
import java.net.UnknownHostException;
import java.util.Date;
import NET.shudo.moba.lang.MobaThread;


class MigrationBenchmark {
  private void start(String[] argv) {
    Runnable r = null;
    if (argv.length > 0)
      r = new LightWeightMigrant(argv[0]);
    else
      r = new LightWeightMigrant();
    Thread t = new MobaThread(r);
    t.start();

    // ưåɤνλԤ
    boolean joined = true;
    do {
      try {
	t.join();
      } catch (InterruptedException e) { joined = false; }
    } while (!joined);
  }

  public static void main(String[] argv) {
    new MigrationBenchmark().start(argv);
  }
}


/**
 * ư륹å
 */
class LightWeightMigrant implements Runnable {
  private static final String DEFAULT_HOST = "host.defaultdomain.com";

  private String destHost = null;
  private InetAddress srcAddr = null;

  private Date time0, time1, time2;

  public LightWeightMigrant() {
    this(DEFAULT_HOST);
  }
  public LightWeightMigrant(String host) {
    this.destHost = host;
  }


  public void run() {
    // data to be transmitted
    double[] data = new double[12800];

    try {
      srcAddr = InetAddress.getLocalHost();
    }
    catch (UnknownHostException e) {
      e.printStackTrace();
      Thread.currentThread().stop();
    }

    time0 = new Date();

    // Ԥ
    try {
      MobaThread.goTo(destHost);
    }
    catch (IOException e) {
      e.printStackTrace();
      Thread.currentThread().stop();
    }

    // 
    try {
      MobaThread.goTo(srcAddr);
    }
    catch (IOException e) {
      e.printStackTrace();
      Thread.currentThread().stop();
    }

    time2 = new Date();


    // output

    System.out.println("begin: " + time0.getTime());
    System.out.println("end  : " + time2.getTime());

    System.out.println("all over: " + (time2.getTime() - time0.getTime()));
  }
}
