/*
 * Copyright (C) 1996,1997,1998
 *	SHUDOH Kazuyuki
 *
 * Permission to use, copy, modify and distribute this software
 * and its documentation for non-commercial purposes and without
 * fee is hereby granted provided this copyright notice.
 *
 * $Id$
 */

package NET.shudo.moba.util;


import java.util.Vector;
import java.util.Enumeration;
import java.util.Stack;
import java.io.PrintStream;


/**
 * ꤷ֥Ȥ򻲾ȤƤ륪֥Ȥ󤹤롣<BR>
 * NET.shudo.moba.util.ReferenceTracer λ㡣
 *
 * @see NET.shudo.moba.util.ReferenceTracer
 */
public
class ReferrerLister implements TracerAction {
  Object target;
  ReferenceTracer tracer;
  Vector referrerTable;
  Vector chainTable;


  public ReferrerLister(Object obj, Object root) {
    this.target = obj;
    this.tracer = new ReferenceTracer(root, this);

    this.referrerTable = new Vector();
    this.chainTable = new Vector();

    tracer.go();
    tracer.reset();
  }


  public Object[] list() {
    int numElem = this.referrerTable.size();
    Object[] ret = new Object[numElem];
    this.referrerTable.copyInto(ret);

    return ret;
  }

  /**
   * ꤵ줿֥Ȥ򻲾ȤƤ륪֥Ȥ󤹤롣
   *
   * @param root õκ
   */
  public static Object[] list(Object obj, Object root) {
    ReferrerLister lister = new ReferrerLister(obj, root);
    return lister.list();
  }

  public Object[] listOfReferenceChain() {
    int numVec = this.referrerTable.size();
    Object[] ret = new Object[numVec];
    this.chainTable.copyInto(ret);

    for (int i = 0; i < numVec; i++) {
      Stack s = (Stack)ret[i];
      int numStack = s.size();
      ret[i] = new Object[numStack];

      int index = 0;
      Object[] retElem = (Object[])ret[i];
      while (!s.isEmpty()) {
	retElem[index++] = s.pop();
      }
    }

    return ret;
  }

  /**
   * ꤵ줿֥Ȥؤλȴط󤹤롣<BR>
   *
   * @return ȤΥǤ Object[] 
   */
  public static Object[] listOfReferenceChain(Object obj, Object root) {
    ReferrerLister lister = new ReferrerLister(obj, root);
    return lister.listOfReferenceChain();
  }

  public static void show(PrintStream out, Object obj, Object root) {
    Object[] list = listOfReferenceChain(obj, root);

    for (int i = 0; i < list.length; i++) {
      Object[] refChain = (Object[])list[i];
      int chainLen = refChain.length;
      if (chainLen > 0) {
	out.println(refChain[0]);
	for (int j = 0; j < refChain.length; j++) {
	  Object referrer = refChain[j];
	  out.print("  referred by ");
	  out.println(referrer);
	}
      }
    }

    out.flush();
  }


  public void process(Object own, Object referrer, Stack refStack) {
/*
System.out.println("process called.");
System.out.println(" class of own: " + own.getClass().getName());
System.out.println(" own     : " + own);
System.out.println(" referrer: " + referrer);
System.out.flush();
*/
    if (own == target) {
      this.referrerTable.addElement(referrer);
      this.chainTable.addElement(refStack.clone());
    }
  }
}
